(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "diacritics"], factory);
    }
})(function (require, exports) {
    "use strict";
    // string.js slugify drops non ascii chars so we have to
    // use a custom implementation here
    // @ts-ignore
    const diacritics_1 = require("diacritics");
    // eslint-disable-next-line no-control-regex
    const rControl = /[\u0000-\u001f]/g;
    const rSpecial = /[\s~`!@#$%^&*()\-_+=[\]{}|\\;:"'<>,.?/]+/g;
    return function slugify(str) {
        return diacritics_1.remove(str)
            // Remove control characters
            .replace(rControl, '')
            // Replace special characters
            .replace(rSpecial, '-')
            // Remove continous separators
            .replace(/-{2,}/g, '-')
            // Remove prefixing and trailing separtors
            .replace(/^-+|-+$/g, '')
            // ensure it doesn't start with a number (#121)
            .replace(/^(\d)/, '_$1')
            // lowercase
            .toLowerCase();
    };
});
